package com.prolog.eis.service.out.impl;

import com.prolog.eis.dao.out.ContainerInfoDetailMapper;
import com.prolog.eis.model.container.ContainerInfoDetail;
import com.prolog.eis.service.out.ContainerInfoDetailService;
import com.prolog.framework.core.restriction.Criteria;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @author zmr
 * @description: 容器信息详情表-服务实现类
 * @date 2023-08-30 12:24
 */
@Service
public class ContainerInfoDetailServiceImpl implements ContainerInfoDetailService {

    @Autowired
    private ContainerInfoDetailMapper containerInfoDetailMapper;

    /**
     * 新增数据
     *
     * @param containerInfoDetail 容器信息详情表
     */
    @Override
    public long save(ContainerInfoDetail containerInfoDetail) {
        return containerInfoDetailMapper.save(containerInfoDetail);
    }

    /**
     * 新增批量数据
     *
     * @param containerInfoDetailList 容器信息详情表
     */
    @Override
    public long saveBatch(List<ContainerInfoDetail> containerInfoDetailList) {
        return containerInfoDetailMapper.saveBatch(containerInfoDetailList);
    }

    /**
     * 查询多条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象列表
     */
    @Override
    public List<ContainerInfoDetail> findByMap(Map<String, Object> paramMap) {
        return containerInfoDetailMapper.findByMap(paramMap, ContainerInfoDetail.class);
    }

    /**
     * 查询单条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象
     */
    @Override
    public ContainerInfoDetail findOneByMap(Map<String, Object> paramMap) {
        List<ContainerInfoDetail> dataList = findByMap(paramMap);
        if(dataList.isEmpty()) {
            return null;
        }
        return dataList.get(0);
    }

    /**
     * 查询多条数据
     *
     * @param criteria 查询起始位置
     * @return 对象列表
     */
    @Override
    public List<ContainerInfoDetail> findByCriteria(Criteria criteria) {
        return containerInfoDetailMapper.findByCriteria(criteria);
    }

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    @Override
    public ContainerInfoDetail findById(int id) {
        return containerInfoDetailMapper.findById(id, ContainerInfoDetail.class);
    }

    /**
     * 修改数据
     *
     * @param containerInfoDetail 实例对象
     */
    @Override
    public long update(ContainerInfoDetail containerInfoDetail) {
        return containerInfoDetailMapper.update(containerInfoDetail);
    }

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     */
    @Override
    public long deleteById(int id) {
        return containerInfoDetailMapper.deleteById(id, ContainerInfoDetail.class);
    }

    /**
     * 通过参数删除数据
     *
     * @param paramMap 参数
     */
    @Override
    public long deleteByMap(Map<String, Object> paramMap) {
        return containerInfoDetailMapper.deleteByMap(paramMap, ContainerInfoDetail.class);
    }

    /**
     * 通过参数查询总条数
     *
     * @param paramMap 参数
     */
    @Override
    public long findCountByMap(Map<String, Object> paramMap) {
        return containerInfoDetailMapper.findCountByMap(paramMap, ContainerInfoDetail.class);
    }
}
